<link rel="import" href="../bower_components/polymer/polymer.html">
<link rel="import" href="../bower_components/pubnub-element/pubnub-element.html">
<dom-module id="chat-service">
    <template>
        <core-pubnub publish_key="pub-c-c50450e7-72e6-47a2-9b3b-0790f8c97745" subscribe_key="sub-c-580da3a4-4a0b-11e7-b730-0619f8945a4f" uuid="[[uuid]]">
            <core-pubnub-history id="hist" channel="[[chatChannel]]" history="{{messages}}" on-success="_loadHistory">
            </core-pubnub-history>
            <core-pubnub-publish id="pub" channel="[[chatChannel]]" message="{}">
            </core-pubnub-publish>
            <core-pubnub-subscribe
                    channel="[[chatChannel]]"
                    id="sub"
                    messages="{{messages}}"
            ></core-pubnub-subscribe>
        </core-pubnub>
    </template>
    <script>
        Polymer({
            is: "chat-service",
            properties: {
                messages: {
                    type: Array,
                    readOnly: true,
                    notify: true,
                    value: []
                },
                username: {
                    type: String
                },
                chatChannel: {
                    type: String
                },
                uuid : {
                    type: Number,
                    value: function () {
                        return randID();
                    }
                }
            },
            ready: function() {
               this.$.pub.message = {};
            },
            _loadHistory: function(e) {
                this._setMessages(this.messages.concat(e.detail[0]));
            },
            sendMessage: function (content) {
                this.$.pub.message = { type:this.chatChannel, text:content, user: this.username, date: new Date(), rid: this.uuid };
                this.$.pub.publish();
            }

        })
        function randID(){  // RandID is just a large number, could be better.
            return Math.floor(Math.random()*10000000);
        }
    </script>
</dom-module>
